part of physics;

/**
 * Stops particles from colliding with each other.
 */
class Collision extends Constraint
{
  Physics _physics;
  double _searchRadius;
  Vector3 _tmp = new Vector3.zero();
  
  Collision(this._physics, [this._searchRadius = 100.0]);
  
  apply(Particle particle) {
    Vector3 position = particle.position;
    List<Particle> neighbours = _physics.space.search(position, _searchRadius);
  
    for(Particle neighbour in neighbours) {
      _tmp.setFrom(position).sub(neighbour.position);
      double distSq = _tmp.length2;
      
      double radius = particle.size + neighbour.size;
      double radiusSq = radius * radius;
      
      if(radiusSq < distSq) {
        var dist = sqrt(distSq);
        _tmp.scale( (dist - radius) / radius * 0.5);
        particle.position.add(_tmp);
        neighbour.position.sub(_tmp);
      }
    }
  }
}